import fetch from "flumm-fetch-cookies";
import crypto from "crypto";
//import config from "../../../../cfg/config.json";

export default class cleverbot {
  constructor() {
    return (async () => {
      await this.init();
      return this;
    })();
  }

  async init() {
    return await fetch("https://www.cleverbot.com/");
  }

  async ask(stimulus) {
    let body = `stimulus=${escape(stimulus)}&cb_settings_scripting=no&islearning=1&icognoid=ws&icognocheck=`;
    body += crypto.createHash("md5").update(body.substring(7, 33)).digest("hex");

    return decodeURIComponent((await fetch("https://www.cleverbot.com/webservicemin?uc=UseOfficialCleverbotAPI", {
      method: "POST",
      body: body
    })).headers["cboutput"]);
  }
};


/*export default new class cleverbot {
  constructor() {
    this.api = "https://cleverbot.io/1.0";
    this.nick = "";
    this.init();
  }

  init() {
    const options = {
      method: "POST",
      body: {
        ...config.apis.cleverbot,
        ...{ nick: "uwibot" }
      }
    };
    fetch(`${this.api}/create`, options)
      .then(res => res.json())
      .then(res => this.nick = res.status === "success" ? res.nick: "uwibot")
      .catch(err => console.log("cleverbot is offline or whatever lol"));
  }

  ask(msg) {
    return new Promise((resolve, reject) => {
      const options = {
        method: "POST",
        body: {
          ...config.apis.cleverbot,
          ...{
            nick: this.nick,
            text: msg
          }
        }
      };
      fetch(`${this.api}/ask`, options)
        .then(res => res.json())
        .then(res => res.status === "success"?resolve(res):reject(res.status))
        .catch(err => reject("cleverbot is offline or whatever lol"));
    });
  }
};*/
